#include <iostream>
#include <boost/format.hpp>
using namespace std;
using namespace boost;

namespace err
{
    enum {Japanese, English};
    enum {NO_FILE, SECTION_BROKEN, /*...*/};

    static const char* message[][2] =
    {
        { "t@C '%1%' J܂łB",
          "File '%1%' could not be opened."
        },
        { "t@C '%1%' ̃ZNV [%2%] jĂ܂B",
          "Section [%2%] in file '%1%' is broken."
        },
        // ...
    };
}

int main(int argc, char* argv[])
{
    int lang = err::Japanese;
    if( argc==2 && argv[1][0]=='e' )
        lang = err::English;

    // ...

    format fmtr( err::message[err::SECTION_BROKEN][lang] );
    cerr << fmtr % "data.archive" % "top_secret" << endl;
    return 0;
}
