#include <iostream>
#include <string>
#include <boost/spirit.hpp>
using namespace std;
using namespace boost::spirit;

void print_int( int x ) { cout << x << "ł[" << endl; }

struct IntList : grammar<IntList>
{
    template<typename ScannerT>
      struct definition
      {
          typedef rule<ScannerT> rule_t;
          rule_t r;
          definition( const IntList& ) { r = int_p[&print_int] % ','; }
          const rule_t& start() const  { return r; }
      };
};

int main()
{
    IntList intl_p;
    if( parse( "1,2,3", intl_p ).full )
         cout << "OK" << endl;
    if( parse( "1,2,3", no_actions_d[intl_p] ).full )
         cout << "OK" << endl;
    return 0;
}
